fdisk: comment out unused function
[oweals/busybox.git] / testsuite / runtest
index c1b1ec2f4ce5e59be5c66a21fde8ec923005264a..93d5ed6e1728baa2f6437cf2fcc1b32c5f66fa00 100755 (executable)
@@ -1,22 +1,20 @@
 #!/bin/sh
 
-[ -n "$srcdir" ] || srcdir=$(pwd)
-[ -n "$bindir" ] || bindir=$(dirname $(pwd))
-PATH=$bindir:$PATH
-
-run_applet_testcase ()
+# Run one old-style test.
+# Tests are stored in applet/testcase shell scripts.
+# They are run using "sh -x -e applet/testcase".
+# Option -e will make testcase stop on the first failed command.
+run_applet_testcase()
 {
        local applet=$1
        local testcase=$2
 
-       local status=0
-       local RES=
-
+       local status
        local uc_applet=$(echo $applet | tr a-z A-Z)
        local testname=$(basename $testcase)
 
        if grep -q "^# CONFIG_${uc_applet} is not set$" $bindir/.config; then
-               echo UNTESTED: $testname
+               echo "UNTESTED: $testname"
                return 0
        fi
 
@@ -24,111 +22,116 @@ run_applet_testcase ()
                local feature=`sed -ne 's/^# FEATURE: //p' $testcase`
 
                if grep -q "^# ${feature} is not set$" $bindir/.config; then
-                       echo UNTESTED: $testname
+                       echo "UNTESTED: $testname"
                        return 0
                fi
        fi
 
-       rm -rf tmp
-       mkdir -p tmp
-       pushd tmp >/dev/null
-
-       d=$srcdir sh -x -e $testcase >.logfile.txt 2>&1
-
-       if [ $? != 0 ] ; then
-               echo FAIL: $testname
-               if [ $verbose -gt 0 ]; then
-                       cat .logfile.txt
-                       #exit 1;
-               fi;
-               status=$?
+       rm -rf ".tmpdir.$applet"
+       mkdir -p ".tmpdir.$applet"
+       cd ".tmpdir.$applet" || return 1
+
+#      echo "Running testcase $testcase"
+       d="$tsdir" sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1
+       status=$?
+       if [ $status != 0 ]; then
+               echo "FAIL: $testname"
+               if [ x"$VERBOSE" != x ]; then
+                       cat "$testname.stdout.txt"
+               fi
        else
-               echo PASS: $testname
-               rm -f .logfile.txt
-               status=$?
+               echo "PASS: $testname"
        fi
 
-       popd >/dev/null
-       rm -rf tmp
+       cd ..
+       rm -rf ".tmpdir.$applet"
 
        return $status
 }
 
-run_applet_tests ()
+# Run all old-style tests for given applet
+run_applet_tests()
 {
        local applet=$1
-
        local status=0
-
-       for testcase in $srcdir/$applet/*; do
-               if [ "$testcase" = "$srcdir/$applet/CVS" ]; then
+       for testcase in $tsdir/$applet/*; do
+               if [ "$testcase" = "$tsdir/$applet/CVS" ]; then
                        continue
                fi
-
-               if run_applet_testcase $applet $testcase; then
-                       :
-               else
-                       status=1
-               fi
+               run_applet_testcase $applet $testcase
+               test $? = 0 || status=1
        done
-
        return $status
 }
 
 
-status=0
-verbose=0
+
+[ -n "$tsdir" ] || tsdir=$(pwd)
+[ -n "$bindir" ] || bindir=$(dirname $(pwd))
+PATH="$bindir:$PATH"
+
+if [ x"$VERBOSE" = x ]; then
+       export VERBOSE=
+fi
 
 if [ x"$1" = x"-v" ]; then
-       verbose=1
-       export VERBOSE=$verbose
+       export VERBOSE=1
        shift
 fi
 
+implemented=$(
+       $bindir/busybox 2>&1 |
+       while read line; do
+               if [ x"$line" = x"Currently defined functions:" ]; then
+                       xargs | sed 's/,//g'
+                       break
+               fi
+       done
+       )
+
+applets="$implemented"
 if [ $# -ne 0 ]; then
-       applets=$(cd $srcdir ; for i in $@; do ls ${i}* ; done)
-else
-       applets=$(ls $srcdir)
+       applets="$@"
 fi
 
-# Set up option flags so tests can be selective.
+# Populate a directory with links to all busybox applets
+
+LINKSDIR="$bindir/runtest-tempdir-links"
+rm -rf "$LINKSDIR" 2>/dev/null
+mkdir "$LINKSDIR"
+for i in $implemented; do
+       ln -s $bindir/busybox "$LINKSDIR"/$i
+done
 
-configfile=${bindir:-../../}/.config
-export OPTIONFLAGS=:$(echo $(sed -nr 's/^CONFIG_(.*)=.*/\1/p' $configfile) | sed 's/ /:/')
+# Set up option flags so tests can be selective.
+export OPTIONFLAGS=:$(sed -nr 's/^CONFIG_//p' $bindir/.config | sed 's/=.*//' | xargs | sed 's/ /:/g')
 
+status=0
 for applet in $applets; do
        if [ "$applet" = "links" ]; then continue; fi
-       if [ "$applet" != "CVS" -a -d "$srcdir/$applet" ]; then
-               if run_applet_tests $applet; then
-                       :
-               else
-                       status=1
-               fi
+
+       # Any old-style tests for this applet?
+       if [ "$applet" != "CVS" -a -d "$tsdir/$applet" ]; then
+               run_applet_tests "$applet"
+               test $? = 0 || status=1
        fi
 
        # Is this a new-style test?
-       applet=$(echo "$applet" | sed -n 's/\.tests$//p')
-       if [ ${#applet} -ne 0 ]
-       then
-               appcfg=`grep -i "^# CONFIG_$applet" $configfile`
-               if [ -n "$appcfg" ]
-               then
-                       echo "SKIPPED: $applet (is configured out)"
+       if [ -f "${applet}.tests" ]; then
+               if [ ! -h "$LINKSDIR/$applet" ] && [ "${applet:0:4}" != "all_" ]; then
+                       echo "SKIPPED: $applet (not built)"
                        continue
                fi
-               # Setup environment for test.
-               if [ -d links ]; then
-                       rm -f links/"$applet" 
-               else
-                       mkdir links 2> /dev/null
-               fi
-               ln -s ${bindir:-../..}/busybox links/"$applet"
-               PATH="$srcdir:$PATH" COMMAND="links/$applet" \
-                       "${srcdir:-.}/$applet".tests
-               if [ $? -ne 0 ]; then status=1; fi
+#              echo "Running test ${tsdir:-.}/${applet}.tests"
+               PATH="$LINKSDIR:$tsdir:$bindir:$PATH" "${tsdir:-.}/${applet}.tests"
+               test $? = 0 || status=1
        fi
-
 done
-rm -f links/*
-rmdir links
+
+# Leaving the dir makes it somewhat easier to run failed test by hand
+#rm -rf "$LINKSDIR"
+
+if [ $status != 0 -a x"$VERBOSE" = x ]; then
+       echo "Failures detected, running with -v (verbose) will give more info"
+fi
 exit $status